/* ===========================================================================
*
*                            PUBLIC DOMAIN NOTICE
*               National Center for Biotechnology Information
*
*  This software/database is a "United States Government Work" under the
*  terms of the United States Copyright Act.  It was written as part of
*  the author's official duties as a United States Government employee and
*  thus cannot be copyrighted.  This software/database is freely available
*  to the public for use. The National Library of Medicine and the U.S.
*  Government have not placed any restriction on its use or reproduction.
*
*  Although all reasonable efforts have been taken to ensure the accuracy
*  and reliability of the software and data, the NLM and the U.S.
*  Government do not and cannot warrant the performance or results that
*  may be obtained by using this software or data. The NLM and the U.S.
*  Government disclaim all warranties, express or implied, including
*  warranties of performance, merchantability or fitness for any particular
*  purpose.
*
*  Please cite the author in any work or product based on this material.
*
* ===========================================================================*/
#ifndef __BLAST_DEGEN__
#define __BLAST_DEGEN__

/* Ambiguous residues are defined using this structure */
typedef struct blast_degen_list {
		int		cnt;		/* no. of letters this chr subsumes */
		BLAST_LetterPtr	list; /* list of matching residues */
	} BLAST_DegenList, PNTR BLAST_DegenListPtr;

typedef struct blast_degenmap {
		BLAST_DegenListPtr	degen; /* degen put first for faster accessing */
		BLAST_AlphabetPtr	ap;
		BLAST_AlphaMapPtr	amp12, amp21;
		BLAST_DegenListPtr	_degen; /* to satisfy Purify */
		struct blast_degenmap PNTR	next;
	} BLAST_DegenMap, PNTR BLAST_DegenMapPtr;

BLAST_DegenMapPtr LIBCALL BlastDegenMapFind PROTO((BLAST_AlphabetPtr ap));

#endif /* !__BLAST_DEGEN__ */
