/* ===========================================================================
*
*                            PUBLIC DOMAIN NOTICE
*               National Center for Biotechnology Information
*
*  This software/database is a "United States Government Work" under the
*  terms of the United States Copyright Act.  It was written as part of
*  the author's official duties as a United States Government employee and
*  thus cannot be copyrighted.  This software/database is freely available
*  to the public for use. The National Library of Medicine and the U.S.
*  Government have not placed any restriction on its use or reproduction.
*
*  Although all reasonable efforts have been taken to ensure the accuracy
*  and reliability of the software and data, the NLM and the U.S.
*  Government do not and cannot warrant the performance or results that
*  may be obtained by using this software or data. The NLM and the U.S.
*  Government disclaim all warranties, express or implied, including
*  warranties of performance, merchantability or fitness for any particular
*  purpose.
*
*  Please cite the author in any work or product based on this material.
*
* ===========================================================================*/
#ifndef __BLAST_RESFREQ__
#define __BLAST_RESFREQ__
#ifdef __cplusplus
extern "C" {
#endif

#ifndef STD_AMINO_ACID_FREQS
#define STD_AMINO_ACID_FREQS	Robinson_prob
#endif

typedef struct _blast_resfreq {
		struct _blast_resfreq PNTR previous, PNTR next;
		Nlm_VoidPtr		user;
		BLAST_AlphabetPtr	ap;
		double				PNTR _prob0, PNTR prob;
	} PNTR BLAST_ResFreqPtr; /* No such animal as a BLAST_ResFreq */


BLAST_Error		_blast_resfreq_init PROTO((void));

BLAST_ResFreqPtr LIBCALL BlastResFreqNew PROTO((BLAST_AlphabetPtr));
BLAST_Error LIBCALL BlastResFreqDestruct PROTO((BLAST_ResFreqPtr));
BLAST_Error LIBCALL BlastResFreqRegister PROTO((BLAST_ResFreqPtr));
Nlm_Boolean LIBCALL BlastResFreqIsRegistered PROTO((BLAST_ResFreqPtr));
BLAST_ResFreqPtr LIBCALL BlastResFreqFind PROTO((BLAST_AlphabetPtr));
BLAST_Error LIBCALL BlastResFreqNormalize PROTO((BLAST_ResFreqPtr rfp, double norm));
BLAST_Error LIBCALL BlastResFreqSet PROTO((BLAST_ResFreqPtr, BLAST_Letter, double));
BLAST_ResFreqPtr LIBCALL BlastResFreqStr PROTO((BLAST_StrPtr));
BLAST_Error LIBCALL BlastResFreqClr PROTO((BLAST_ResFreqPtr));
BLAST_Error LIBCALL BlastResFreqBuf PROTO((BLAST_ResFreqPtr, BLAST_LetterPtr, size_t len));
BLAST_Error LIBCALL BlastResFreqResComp PROTO((BLAST_ResFreqPtr, BLAST_ResCompPtr));
double LIBCALL BlastResFreqStrAlist PROTO((BLAST_StrPtr str, BLAST_AlphabetPtr ap, BLAST_LetterPtr alist, size_t alistlen));

/* Datatypes */
#define ResFreqPtr	BLAST_ResFreqPtr

/* Functions */
#define ResFreqNew	BlastResFreqNew
#define ResFreqDestruct	BlastResFreqDestruct
#define ResFreqRegister	BlastResFreqRegister
#define ResFreqIsRegistered	BlastResFreqIsRegistered
#define ResFreqFind	BlastResFreqFind
#define ResFreqNormalize	BlastResFreqNormalize
#define ResFreqStr	BlastResFreqStr
#define ResFreqSet	BlastResFreqSet
#define ResFreqClr	BlastResFreqClr
#define ResFreqBuf	BlastResFreqBuf
#define ResFreqResComp	BlastResFreqResComp

#ifdef __cplusplus
}
#endif
#endif /* !__BLAST_RESFREQ__ */
